#include <main.h>

#define Tmin 90
#define Tmax 120
#define RC_IN PIN_A2
#define RC_OUT PIN_A1
#define TERM PIN_A0
#define LED_VERDE PIN_A4
#define LED_ROJO PIN_A5
#define PULSO_FS 1000

unsigned int16 y1,x1,y2,x2,b,xa,ya;
int i,ct;
unsigned int16 T;
int tbaja,talta,tok,comok,comnok;


#int_EXT
void  EXT_isr(void) 
{
int16 retardo;

   if (input(RC_IN)) output_high(RC_OUT);
   for (retardo=0;retardo<300;retardo++) {
      if (!input(RC_IN)) break;
   }
   output_low(RC_OUT);
   comok=1;
   comnok=0;
   set_timer2(0);
}

#int_TIMER2
void  TIMER2_isr(void) 
{
   comnok=1;
   comok=0;
   output_high(RC_OUT);
   delay_us(PULSO_FS);
   output_low(RC_OUT);
}

#define OVERSAMPLENR 1


const unsigned int16 temptable[][2] = {
{       23*OVERSAMPLENR ,       300     },
{       25*OVERSAMPLENR ,       295     },
{       27*OVERSAMPLENR ,       290     },
{       28*OVERSAMPLENR ,       285     },
{       31*OVERSAMPLENR ,       280     },
{       33*OVERSAMPLENR ,       275     },
{       35*OVERSAMPLENR ,       270     },
{       38*OVERSAMPLENR ,       265     },
{       41*OVERSAMPLENR ,       260     },
{       44*OVERSAMPLENR ,       255     },
{       48*OVERSAMPLENR ,       250     },
{       52*OVERSAMPLENR ,       245     },
{       56*OVERSAMPLENR ,       240     },
{       61*OVERSAMPLENR ,       235     },
{       66*OVERSAMPLENR ,       230     },
{       71*OVERSAMPLENR ,       225     },
{       78*OVERSAMPLENR ,       220     },
{       84*OVERSAMPLENR ,       215     },
{       92*OVERSAMPLENR ,       210     },
{       100*OVERSAMPLENR        ,       205     },
{       109*OVERSAMPLENR        ,       200     },
{       120*OVERSAMPLENR        ,       195     },
{       131*OVERSAMPLENR        ,       190     },
{       143*OVERSAMPLENR        ,       185     },
{       156*OVERSAMPLENR        ,       180     },
{       171*OVERSAMPLENR        ,       175     },
{       187*OVERSAMPLENR        ,       170     },
{       205*OVERSAMPLENR        ,       165     },
{       224*OVERSAMPLENR        ,       160     },
{       245*OVERSAMPLENR        ,       155     },
{       268*OVERSAMPLENR        ,       150     },
{       293*OVERSAMPLENR        ,       145     },
{       320*OVERSAMPLENR        ,       140     },
{       348*OVERSAMPLENR        ,       135     },
{       379*OVERSAMPLENR        ,       130     },
{       411*OVERSAMPLENR        ,       125     },
{       445*OVERSAMPLENR        ,       120     },
{       480*OVERSAMPLENR        ,       115     },
{       516*OVERSAMPLENR        ,       110     },
{       553*OVERSAMPLENR        ,       105     },
{       591*OVERSAMPLENR        ,       100     },
{       628*OVERSAMPLENR        ,       95      },
{       665*OVERSAMPLENR        ,       90      },
{       702*OVERSAMPLENR        ,       85      },
{       737*OVERSAMPLENR        ,       80      },
{       770*OVERSAMPLENR        ,       75      },
{       801*OVERSAMPLENR        ,       70      },
{       830*OVERSAMPLENR        ,       65      },
{       857*OVERSAMPLENR        ,       60      },
{       881*OVERSAMPLENR        ,       55      },
{       903*OVERSAMPLENR        ,       50      },
{       922*OVERSAMPLENR        ,       45      },
{       939*OVERSAMPLENR        ,       40      },
{       954*OVERSAMPLENR        ,       35      },
{       966*OVERSAMPLENR        ,       30      },
{       977*OVERSAMPLENR        ,       25      },
{       985*OVERSAMPLENR        ,       20      },
{       993*OVERSAMPLENR        ,       15      },
{       999*OVERSAMPLENR        ,       10      },
{       1004*OVERSAMPLENR       ,       5       },
{       1008*OVERSAMPLENR       ,       0       } //safety
};


unsigned int16 gettemp() 
{


   xa=(unsigned int16)read_adc();
   y1=305;
   x1=0;
   for (i=0;i < 61;i++) {
      x2=temptable[i][0];
      y2=temptable[i][1];
      if (xa>=x2) {
         y1=temptable[i][1];   
         x1=temptable[i][0];
      } else {

         ya=xa*(y1-y2);
         ya/=(x2-x1);

         b=x1*(y1-y2);
         b/=(x2-x1);
         b+=y1;
         
         ya=b-ya;
         return(ya);
      }
   }
   return(0);
}


void main()
{
   setup_adc_ports(sAN0);
   setup_adc(ADC_CLOCK_DIV_2);
   set_adc_channel(0);
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_4);      //131 ms overflow
   setup_timer_2(T2_DIV_BY_16,255,15);      //2.0 ms overflow, 30.7 ms interrupt
   enable_interrupts(INT_TIMER2);
   enable_interrupts(INT_EXT);
   enable_interrupts(GLOBAL);
   setup_oscillator(OSC_8MHZ);

   tbaja=1;
   talta=0;
   tok=0;
   comok=0;
   comnok=1;
   set_timer1(0);
   ct=0;
   
   while(TRUE) {
      if (get_timer1()>15000) {
         set_timer1(0);      
         if (ct==10) {
            if (tbaja) {
               output_high(LED_ROJO);
            }
            if (tok) {
               output_low(LED_ROJO);
            }
            if (talta) {
               output_low(LED_ROJO);
            }
            if (comnok) {
               output_high(LED_VERDE);
            }
            if (!comnok) {
               output_low(LED_VERDE);
            }
            
         } 
         if (ct==20) {
            ct=0;
            if (tbaja) {
               output_high(LED_ROJO);
            }
            if (tok) {
               output_high(LED_ROJO);
            }
            if (talta) {
               output_low(LED_ROJO);
            }
            if (comnok) {
               output_high(LED_VERDE);
            }
            if (!comnok) {
               output_low(LED_VERDE);
            }

            T=gettemp();
            tok=1;
            talta=tbaja=0;
            if (T<Tmin) {
               tbaja=1;
               talta=tok=0;
            }
            if (T>Tmax) {
               talta=1;
               tbaja=tok=0;
            }
         }
         ct++;

      }
   
      
   }

}








